package ex02;

import java.util.Scanner;

public class Principal {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int op, opcao, cont = 0, pos, resp;
		int posFunc;
		Funcionario funcs[] = new Funcionario[300];

		do{
			System.out.println("--====[Opções]====--");
			System.out.println("1 - Funcionário");
			System.out.println("2 - Filho");
			System.out.println("3 - Sair");
			System.out.print("Opção: ");
			opcao = sc.nextInt();
		
			switch(opcao){
			    case 1:
					do {
						System.out.println("-==[Funcionários]==-");
						System.out.println("1 - Inclusão");
						System.out.println("2 - Exclusão");
						System.out.println("3 - Alteração");
						System.out.println("4 - Consulta");
						System.out.println("5 - Relatório Funcionários");
						System.out.println("6 - Relatório Funcionários/Filhos");
						System.out.println("7 - Voltar ao menu principal");
						System.out.print("Opção: ");
						op = sc.nextInt();
			
						switch (op) {
						case 1:
			                
							cont = 0;
							while ((cont < funcs.length) && (funcs[cont] != null)) {
								cont++;
							}
			
							if (cont > (funcs.length - 1)) {
								System.out.println("Vetor cheio!");
							} else {
								Funcionario fu = new Funcionario();
			
								System.out.println("-=[Inserir Funcionário]=-");
								System.out.println("Nome: ");
								fu.setNome(sc.next());
								System.out.println("CPF: ");
								fu.setCpf(sc.next());
								System.out.println("Salário: ");
								fu.setSalario(sc.nextFloat());
								System.out.println("Identidade: ");
								fu.setIdentidade(sc.next());
			
								funcs[cont] = fu;
							}
			
							break;
						case 2:
							System.out.println("-=[Exclusão Funcionário]=-");
							System.out.println("Qual posição deseja excluir?");
							pos = sc.nextInt();
			
							if ((pos >= 0) && (pos < funcs.length) && (funcs[pos] != null)) {
								imprimeFuncionario(funcs[pos]);
			
								System.out.println("Confirma a exclusão?(1-Sim/2-não)");
								resp = sc.nextInt();
			
								if (resp == 1) {
									funcs[pos] = null;
									System.out.println("Exclusão efetuada com sucesso.");
								} else {
									System.out.println("Exclusão não efetuada.");
								}
							} else {
								System.out.println("Fucionário não encontrado.");
							}
			
							break;
						case 3:
							System.out.println("-=[Alteração Funcionário]=-");
							System.out.println("Qual posição deseja alterar?");
							pos = sc.nextInt();
			
							if ((pos >= 0) && (pos < funcs.length) && (funcs[pos] != null)) {
								imprimeFuncionario(funcs[pos]);
			
								System.out.println("Confirma a alteração?(1-Sim/2-não)");
								resp = sc.nextInt();
			
								if (resp == 1) {
									System.out.println("Nome: ");
									funcs[pos].setNome(sc.next());
									System.out.println("CPF: ");
									funcs[pos].setCpf(sc.next());
									System.out.println("Salário: ");
									funcs[pos].setSalario(sc.nextFloat());
									System.out.println("Identidade: ");
									funcs[pos].setIdentidade(sc.next());
			
									System.out.println("Alteração efetuada com sucesso.");
								} else {
									System.out.println("Alteração não efetuada.");
								}
							} else {
								System.out.println("Funcionário não encontrado.");
							}
			
							break;
						case 4:
							System.out.println("-=[Consulta Funcionário]=-");
							System.out.println("Qual posição deseja consultar?");
							pos = sc.nextInt();
			
							if ((pos >= 0) && (pos < funcs.length) && (funcs[pos] != null)) {
								imprimeFuncionario(funcs[pos]);
							} else {
								System.out.println("Funcionário não encontrado.");
							}
							break;
						case 5:
							System.out.println("-=[Relatório Funcionários]=-");
							for (int i = 0; i < funcs.length; i++) {
								if (funcs[i] != null) {
									imprimeFuncionario(funcs[i]);
								}
							}
							break;
						case 6:
							System.out.println("-=[Relatório Funcionários / Filhos]=-");
							for (int i = 0; i < funcs.length; i++) {
								if (funcs[i] != null) {
									imprimeFuncionarioComFilhos(funcs[i]);
								}
							}
							break;
						}
					} while (op != 7);
					break;
			    case 2:
					do {
						System.out.println("-==[Filhos]==-");
						System.out.println("1 - Inclusão");
						System.out.println("2 - Exclusão");
						System.out.println("3 - Alteração");
						System.out.println("4 - Consulta");
						System.out.println("5 - Relatório");
						System.out.println("6 - Voltar ao menu principal");
						System.out.print("Opção: ");
						op = sc.nextInt();
			
						switch (op) {
						case 1:
							System.out.println("Qual a posição do funcionário no vetor?");
							posFunc = sc.nextInt();
							
							if(funcs[posFunc] != null){
								imprimeFuncionario(funcs[posFunc]);
								
								int respFunc;
								System.out.println("Confirma o funcionário?(1-sim/2-não): ");
								respFunc = sc.nextInt();
								
								if(respFunc == 1){
									cont = 0;
									while ((cont < funcs[posFunc].getFilhos().length) && 
											(funcs[posFunc].getFilhos()[cont] != null)) {
										cont++;
									}
					
									if (cont > (funcs[posFunc].getFilhos().length - 1)) {
										System.out.println("Vetor cheio!");
									} else {
										Filho fi = new Filho();
					
										System.out.println("-=[Inserir Filho]=-");
										System.out.println("Nome: ");
										fi.setNome(sc.next());
										System.out.println("CPF: ");
										fi.setCpf(sc.next());
										System.out.println("Número Certidão Nascimento: ");
										fi.setNumCertNasc(sc.next());
										System.out.println("Data Nascimento: ");
										fi.setDataNascimento(sc.nextInt());
					
										funcs[posFunc].getFilhos()[cont] = fi;
									}
								}
								else{
									System.out.println("Inclusão cancelada!");
								}
							}
							break;

						case 2:
							System.out.println("-=[Exclusão Filho]=-");
							System.out.println("Qual a posição do funcionário no vetor?");
							posFunc = sc.nextInt();

							System.out.println("Qual posição do filho deseja excluir?");
							pos = sc.nextInt();
			
							if ((pos >= 0) && (pos < funcs[posFunc].getFilhos().length) && 
									(funcs[posFunc].getFilhos()[pos] != null)) {
								imprimeFilho(funcs[posFunc].getFilhos()[pos]);
			
								System.out.println("Confirma a exclusão?(1-Sim/2-não)");
								resp = sc.nextInt();
			
								if (resp == 1) {
									funcs[posFunc].getFilhos()[pos] = null;
									System.out.println("Exclusão efetuada com sucesso.");
								} else {
									System.out.println("Exclusão não efetuada.");
								}
							} else {
								System.out.println("Filho não encontrado.");
							}
			
							break;
						case 3:
							System.out.println("-=[Alteração Funcionário]=-");
							System.out.println("Qual a posição do funcionário no vetor?");
							posFunc = sc.nextInt();
							System.out.println("Qual posição deseja alterar?");
							pos = sc.nextInt();
			
							if ((pos >= 0) && (pos < funcs[posFunc].getFilhos().length) && 
									(funcs[posFunc].getFilhos()[pos] != null)) {
								imprimeFilho(funcs[posFunc].getFilhos()[pos]);
			
								System.out.println("Confirma a alteração?(1-Sim/2-não)");
								resp = sc.nextInt();
			
								if (resp == 1) {
									System.out.println("Nome: ");
									funcs[posFunc].getFilhos()[pos].setNome(sc.next());
									System.out.println("CPF: ");
									funcs[posFunc].getFilhos()[pos].setCpf(sc.next());
									System.out.println("Salário: ");
									funcs[posFunc].getFilhos()[pos].setNumCertNasc(sc.next());
									System.out.println("Identidade: ");
									funcs[posFunc].getFilhos()[pos].setDataNascimento(sc.nextInt());
			
									System.out.println("Alteração efetuada com sucesso.");
								} else {
									System.out.println("Alteração não efetuada.");
								}
							} else {
								System.out.println("Funcionário não encontrado.");
							}
			
							break;
						case 4:
							System.out.println("-=[Consulta Filho]=-");
							System.out.println("Qual a posição do funcionário no vetor?");
							posFunc = sc.nextInt();
							System.out.println("Qual posição deseja consultar?");
							pos = sc.nextInt();
			
							if ((pos >= 0) && (pos < funcs[posFunc].getFilhos().length) && 
									(funcs[posFunc].getFilhos()[pos] != null)) {
								imprimeFilho(funcs[posFunc].getFilhos()[pos]);
							} else {
								System.out.println("Filho não encontrado.");
							}
							break;
						case 5:
							System.out.println("-=[Relatório Filhos]=-");
							System.out.println("Qual a posição do funcionário no vetor?");
							posFunc = sc.nextInt();
							for (int i = 0; i < funcs[posFunc].getFilhos().length; i++) {
								if (funcs[posFunc].getFilhos()[i] != null) {
									imprimeFilho(funcs[posFunc].getFilhos()[i]);
								}
							}
						}
					} while (op != 6);
			    	break;
			}
	    }while(opcao != 3);
		
		sc.close();
	}

	public static void imprimeFuncionario(Funcionario f){
    	System.out.println("-------------------------------------");
    	System.out.println("Nome: " + f.getNome());
    	System.out.println("CPF: " + f.getCpf());
    	System.out.println("Identidade: " + f.getIdentidade());
    	System.out.println("Salário: " + f.getSalario());
    }
	
	public static void imprimeFuncionarioComFilhos(Funcionario func){
    	System.out.println("====================================");
    	imprimeFuncionario(func);
    	System.out.println("-------------------------------------");
        
    	for(int i = 0; i < func.getFilhos().length; i++){
    		if(func.getFilhos()[i] != null)
    			imprimeFilho(func.getFilhos()[i]);
        }
    }
	
	public static void imprimeFilho(Filho f){
		System.out.println("--------------------------------------------");
		System.out.println("Nome: " + f.getNome());
		System.out.println("CPF: " + f.getCpf());
		System.out.println("Número Certidão Nascimento: " + f.getNumCertNasc());
		System.out.println("Data de Nascimento: " + f.getDataNascimento());
	}
}
